rm(list=ls())

#chargement des donnes
library(xlsx)
don <- read.xlsx("autos_small_ict.xlsx",header=T,sheetIndex=1)
rownames(don) <- as.character(don[,1])
don <- don[-1]
colnames(don) <- c("Prix","Cylindree","Puissance","Poids","Conso")
print(head(don))


#fonction de centrage rduction
CR <- function(x){
  n <- length(x)
  m <- mean(x)
  et <- sqrt((n-1)/n*var(x))
  return((x-m)/et)
}

#centrage rduction des variables
don.cr <- as.data.frame(lapply(don,CR))
print(head(don.cr))

#chargement de party
library(party)

arbre <- ctree(. ~ don$Prix+don$Cylindree+don$Puissance+don$Poids+don$Conso, data = don.cr,controls = ctree_control(minsplit=10,minbucket=5,mincriterion=0.8))
print(arbre)
