rm(list=ls())

#chargement des donnes
library(xlsx)
don <- read.xlsx("autos_small_ict.xlsx",header=T,sheetIndex=1)
rownames(don) <- as.character(don[,1])
don <- don[-1]
print(head(don))

#fonction de centrage rduction
CR <- function(x){
  n <- length(x)
  m <- mean(x)
  et <- sqrt((n-1)/n*var(x))
  return((x-m)/et)
}

#centrage rduction des variables
don.cr <- as.data.frame(lapply(don,CR))
print(head(don.cr))

#matrice de distance sur donnes centres-rduites
n <- nrow(don.cr)
d <- dist(don.cr,"euclidean")

#T = n * intertie totale
T <- n * ((1/n^2)*sum(d^2))
print(T)

#tri selon Poids
index <- order(don$Poids)

#recherche des bornes
#ne pas prendre en compte les feuilles de - de 5 individus (paramtre arbre)
bornes <- numeric(0)
gain <- numeric(0)
k <- 0
for (i in 6:(n-4)){
  #premire portion des donnes (branche gauche)
  dg <- don.cr[index[1:(i-1)],] #donnes
  ng <- nrow(dg) #nb d'obs
  Sg <- ng * ((1/ng^2)*sum(dist(dg,"euclidean")^2)) #n * inertie
  #seconde portion des donnes (branche droite)
  dd <- don.cr[index[i:n],] #donnes
  nd <- nrow(dd) #nb d'obs
  Sd <- nd * ((1/nd^2)*sum(dist(dd,"euclidean")^2))
  #inertie intra
  W <- Sg + Sd
  #borne de dcoupage
  b <- 0.5*(don$Poids[index[i-1]] + don$Poids[index[i]])
  #gain inertie (en pourcentage)
  B <- (T-W)/T*100
  #critre de Ward aurait fonctionn galement
  #mg <- colMeans(dg)
  #md <- colMeans(dd)
  #delta <- (ng*nd)/(ng+nd)*sum((mg-md)^2)
  #B <- delta/T*100
  #collecter
  k <- k+1
  bornes[k] <- b
  gain[k] <- B
}

#affichage : bornes de dcoupage et gains associs
print(cbind(bornes,gain))
